function math:GetOrdinal(number)
	local ordinal = "th";
	if number == 1 then
		ordinal = "st";
	elseif number == 2 then
		ordinal = "nd";
	elseif number == 3 then
		ordinal = "rd";
	end
	
	return string.format("%d%s", number, ordinal);
end

function math:RoundToInt(number)
	return math:Round(number, false);
end

function math:Round(number, decimalPlaces)
	if decimalPlaces then
		return math.floor((number * 10 ^ decimalPlaces) + 0.5) / (10 ^ decimalPlaces)
	else
		return math.floor(number + 0.5)
	end
end

function math:IsValidInt(numberText, minValue, maxValue)
	if string.match(numberText, "^%d+$") then
		local number = tonumber(numberText);
		if (minValue == nil or number >= minValue) and (maxValue == nil or number <= maxValue) then
			return true;
		end
	end
	
	return false;
end

function math:FormatNumber(amount, decimalPlaces, negativePrefix)
	local str_amount,  formatted, famount, remain

	decimalPlaces = decimalPlaces or 2
	negativePrefix = negativePrefix or "-"

	famount = math.abs(math:Round(amount, decimalPlaces))
	famount = math.floor(famount)

	remain = math:Round(math.abs(amount) - famount, decimalPlaces)

	formatted = famount

	if decimalPlaces > 0 then
		remain = string.sub(tostring(remain),3)
		formatted = formatted .. Symbols["decimal_point"] .. remain .. string.rep("0", decimalPlaces - string.len(remain))
	end

	if amount < 0 then
		if negativePrefix == "()" then
			formatted = "(" .. formatted .. ")"
		else
			formatted = negativePrefix .. formatted 
		end
	end

	return formatted
end