OptionsPanel = class(Turbine.UI.Control);

local Constants =
{
	Size =
	{
		Width = 400,
		Height = 100,
		CheckBoxWide = 240
	},
	Padding =
	{
		Left = 10,
		Top = 10
	},
	RowWidth = 180,
	LineSpacing = 4
}

function OptionsPanel:Constructor()
	Turbine.UI.Control.Constructor(self);

    self:SetSize(Constants.Size.Height, Constants.Size.Width);
	
	local top = Constants.Padding.Top;
	local left = Constants.Padding.Left;
	
	self.GlobalSettingsButton = CreateCheckBox(self, left, top, Constants.Size.CheckBoxWide, Globals.Sizes.CheckBoxOnly.Height, Strings["use_global_settings"]);
    self.GlobalSettingsButton:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.GlobalSettingsButton:SetChecked(GlobalSettings.UseGlobalSettings);
	self.GlobalSettingsButton.CheckedChanged = function(sender, args)
		local isChecked = self.GlobalSettingsButton:IsChecked();
		GlobalSettings.UseGlobalSettings = isChecked;
	end
	
	top = top + self.GlobalSettingsButton:GetHeight() + Constants.LineSpacing;
	
	local buttonAdjuster = UIOptions["wide_options_button"] and 2 or 1;
	
	local statusButton = CreateButton(self, buttonAdjuster);
	statusButton:SetPosition(left, top);
	statusButton:SetText(Strings["status"])
	statusButton.Click = function(sender, args)
		StatusWindow:Show();
	end

	top = top + statusButton:GetHeight() + Constants.LineSpacing;

	local listFilterButton = CreateButton(self, buttonAdjuster);
	listFilterButton:SetPosition(left, top);
	listFilterButton:SetText(Strings["list_filters"])
	listFilterButton.Click = function(sender, args)
		ListBabbleFilters();
	end	
end
